using Entidades;

namespace Modelo
{
    public sealed class RepositorioClientes : RepositorioBase<Cliente, RepositorioClientes>
    {
        public override bool Add(Cliente t)
        {
            bool ret = false;
            try
            {
                almacen.Add(t);
                ret = true;
            }
            catch (Exception)
            {
                throw;
            }

            return ret;
        }
        // Método para verificar si el CUIT ya existe
        public bool ExistePorCuit(long cuit)
        {
            return almacen.Any(c => c.Cuit == cuit);
        }

        override public bool Mod(Cliente t)
        {
            bool ret = false;
            try
            {
                var clienteAModificar = almacen.FindIndex(x => x.Cuit == t.Cuit);
                if (clienteAModificar > -1)
                {
                    almacen[clienteAModificar] = t; 
                    ret = true;
                }
            }
            catch (Exception)
            {
                throw;
            }

            return ret;
        }

        override public bool Del(Cliente t)
        {
            bool ret = false;

            try
            {
                var clienteAEliminar = almacen.Find(x => x.Cuit == t.Cuit);
                if (clienteAEliminar != null)
                {
                    clienteAEliminar.Habilitado = false;
                    ret = true;
                }
            }
            catch (Exception)
            {
                throw;
            }

            return ret;
        }
    }
}

